﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Windows.Data;

namespace Hardcodet.Wpf.DataBinding.Sample
{
  /// <summary>
  /// A very simple converter which converts dots to
  /// dashes.
  /// </summary>
  public class CharConverter : IValueConverter
  {
    public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
    {
      if (value == null) return value;

      string param = (string)(parameter ?? "#");
      return value.ToString().Replace(".", param);
    }


    ///<summary>
    ///Converts a value. 
    ///</summary>
    ///<returns>
    ///A converted value. If the method returns null, the valid null value is used.
    ///</returns>
    ///<param name="value">The value that is produced by the binding target.</param>
    ///<param name="targetType">The type to convert to.</param>
    ///<param name="parameter">The converter parameter to use.</param>
    ///<param name="culture">The culture to use in the converter.</param>
    public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
    {
      if (value == null) return value;

      string param = (string)(parameter ?? "#");
      return value.ToString().Replace(param, ".");
    }
  }
}
