﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Input;


namespace Hardcodet.Wpf.DataBinding.Sample
{
  public class InputHandler
  {
    private readonly Key lookupKey;


    /// <summary>
    /// Creates a handler with a given input control and a lookup key.
    /// </summary>
    /// <param name="inputControl"></param>
    /// <param name="lookupKey"></param>
    private InputHandler(DependencyObject inputControl, Key lookupKey)
    {
      this.lookupKey = lookupKey;
      Keyboard.AddKeyUpHandler(inputControl, OnKeyUp);
    }



    //this is were the custom work would be made. for this sample, just
    //show a message box
    private void OnKeyUp(object sender, KeyEventArgs e)
    {
      if (e.Key != lookupKey) return;

      string msg = "Lookup key {0} was pressed";
      msg = String.Format(msg, lookupKey);
      MessageBox.Show(msg);
    }


    public static void RegisterHandler(DependencyObject inputControl, Key lookupKey)
    {
      InputHandler handler = new InputHandler(inputControl, lookupKey);
    }
  }
}