﻿using System;
using System.Windows;
using System.Windows.Input;


namespace Hardcodet.Wpf.DataBinding.Sample
{
  public class LookupExtension : BindingDecoratorBase
  {
    //A key which will trigger a lookup when pressed.
    public Key LookupKey { get; set; }




    /// <summary>
    /// This method is being invoked during initialization.
    /// </summary>
    /// <param name="provider">Provides access to the bound items.</param>
    /// <returns>The binding expression that is created by
    /// the base class.</returns>
    public override object ProvideValue(IServiceProvider provider)
    {

      //delegate binding creation etc. to the base class
      object val = base.ProvideValue(provider);

      
      //try to get bound items for our custom work
      DependencyObject targetObject;
      DependencyProperty targetProperty;
      bool status = TryGetTargetItems(provider, out targetObject, out targetProperty);

      if (status)
      {
        //associate an input listener with the control
        InputHandler.RegisterHandler(targetObject, LookupKey);
      }

      return val;
    }
  }
}
